"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultIterableAccessImpl = exports.DefaultMapAccessImpl = void 0;
const generic_1 = require("./generic");
class DefaultMapAccessImpl {
    nextEntrySeed(kseed, vseed) {
        const key = this.nextKeySeed(kseed);
        if (key !== undefined) {
            const value = this.nextValueSeed(vseed);
            if (value !== undefined) {
                return [key, value];
            }
        }
    }
    nextKey() {
        return this.nextValueSeed((generic_1.GenericSeed));
    }
    nextValue() {
        return this.nextValueSeed((generic_1.GenericSeed));
    }
    nextEntry() {
        return this.nextEntrySeed((generic_1.GenericSeed), (generic_1.GenericSeed));
    }
}
exports.DefaultMapAccessImpl = DefaultMapAccessImpl;
class DefaultIterableAccessImpl {
    nextElement() {
        return this.nextElementSeed((generic_1.GenericSeed));
    }
    sizeHint() { return 0; }
}
exports.DefaultIterableAccessImpl = DefaultIterableAccessImpl;
